BOOT   ;boot/asm
 	ORG	4300H
 BUFFER	EQU	4400H
 	DI
 	LD	HL,NMIRET
 	LD	(404AH),HL
 	LD	A,0C3H
 	LD	(4049H),A
 	LD	DE,0100H
 	LD	L,-1
 	EXX
 LOOP	CALL	GET1B
 	CP	1
 	JR	Z,LOAD
 	CP	2
 	JR	Z,START
 	CP	20H
 	JP	NC,ERROR
 	CALL	GET1B
 	LD	B,A
 LOOP2	CALL	GET1B
 	DJNZ	LOOP2
 	JR	LOOP
 START	CALL	GET1B
 	CALL	GETLOAD
 	JP	(HL)
 GETLOAD	CALL	GET1B
 	LD	L,A
 	CALL	GET1B
 	LD	H,A
 	RET
 LOAD	CALL	GET1B
 	LD	B,A
 	CALL	GETLOAD
 	DEC	B
 	DEC	B
 LOAD2	CALL	GET1B
 	LD	(HL),A
 	CP	(HL)
 	JP	NZ,ERROR
 	INC	HL
 	DJNZ	LOAD2
 	JR	LOOP		;go again
 SELECT	LD	A,81H
 	OUT	(0F4H),A
 	RET
 GET1B	EXX
 	INC	L
 	JR	NZ,HAVE1B
 	LD	HL,BUFFER
 	CALL	READ
 	CALL	NZ,READ
 	JP	NZ,ERROR
 	INC	E
 	LD	A,E
 	SUB	12H
 	JR	NZ,HAVE1B
 	LD	E,A
 	INC	D
 HAVE1B	LD	A,(HL)
 	EXX
 	RET
 READ	CALL	SELECT
 	CALL	SEEK
 	CALL	SETNMI
 	LD	A,80H
 	OUT	(0F0H),A
 	CALL	DSKSLO
 	LD	A,0C0H
 	OUT	(0E4H),A
 READ1	IN	A,(0F0H)
 	AND	E
 	JR	Z,READ1
 	INI
 	LD	A,D
 	OR	40H
 READ2	OUT	(0F4H),A
 	INI
 	JR	NZ,READ2
 	JR	$
 SETNMI	LD	(SECSAVE),DE
 	LD	(BUFFSAVE),HL
 	LD	DE,RETNMI
 	LD	(404AH),DE
 	LD	BC,0F3H
 	LD	DE,8102H
 	IN	A,(0F0H)
 	RET
 RETNMI	POP	HL
 	LD	DE,0
 SECSAVE	EQU	$-2
 	LD	HL,NMIRET
 	LD	(404AH),HL
 	LD	HL,0
 BUFFSAVE	EQU	$-2
 	XOR	A
 	OUT	(0E4H),A
 	CALL	DSKSLO
 	IN	A,(0F0H)
 	AND	9FH
 	RET
 NMIRET	RETN
 DSKSLO	PUSH	BC
 	LD	B,10
 	DJNZ	$
 	POP	BC
 	RET
 SEEK	LD	A,D
 	OUT	(0F3H),A
 	CALL	SELECT
 	LD	A,1BH
 	OUT	(0F0H),A
 	CALL	DSKSLO
 SEEKWT	IN	A,(0F0H)
 	BIT	0,A
 	JR	NZ,SEEKWT
 SEEKOK	LD	A,E
 	OUT	(0F2H),A
 	RET
 ERROR	LD	HL,MSG
 	CALL	21BH
 	CALL	40H
 	RST	0
 MSG	DB	1CH,1FH,'* Error * ',3
 	DB	0,0
 	END	4300H
